import logging
import numpy as np
from tqdm import tqdm
import torch
from graphmae.datasets_bulid import Gbuild_z
import warnings
warnings.filterwarnings("ignore", category=UserWarning)
from graphmae.utils import (
    build_args,
    create_optimizer,
    set_random_seed,
    TBLogger,
    get_current_lr,
    load_best_configs,
)
import random
import numpy as np
import pandas as pd
from graphmae.utils import build_args
random_seed =2

random.seed(random_seed) 
np.random.seed(random_seed )
torch.manual_seed(random_seed )
torch.cuda.manual_seed_all(random_seed )
torch.backends.cudnn.deterministic = True

import dgl
dgl.random.seed(random_seed)

from graphmae.models import IDEC_process

logging.basicConfig(format="%(asctime)s - %(levelname)s - %(message)s", level=logging.INFO)


def gcae_imputation(args,graph,files):
    egFolder_model = "./GraCEImpute_imputation_model/"

    model_z = IDEC_process(args)

    model_z.load_state_dict(
        torch.load(str(egFolder_model) + str(files) + "_lr_" +
                   str(args.lr_f) + "_max_epoch_" + str(args.max_epoch_f) + "_in_drop_" + str(
            args.in_drop) + "_attn_drop_" +
                   str(args.attn_drop) + "_imp_model.pt")) 
    model_z.eval()
    x1, _ = model_z(graph, graph.ndata["feat"])
    data_z = x1.detach().numpy()
    return data_z
if __name__ == "__main__":

    egFolderO = "./GraCEImpute_imputation_data/"
    egFolder1 = "./GraCEImpute_disimpetuation_data/"
    model_name = "GraCEImpute"
    args = build_args()
    data = pd.read_csv("../GSE81861_feature.csv", index_col=0)

    graph, num_features = Gbuild_z.data_processing(data)
    args.num_features = num_features
    res = gcae_imputation(args, graph,i)
    res = pd.DataFrame(res, index=data.index, columns=data.columns)
    print("finish")
    res.to_csv(egFolderO + str(model_name) + "_" + str(i)  + "_imp_data.csv")
    #Need to imputate back to the original dataset














































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































